<?php
/*
** File:           emaillib.php
** Author:         nuSoftware
** Created:        2009/12/09
** Last modified:  2009/12/09
**
** Copyright 2004, 2005, 2006, 2007, 2008, 2009 nuSoftware
**
** This file is part of the nuBuilder source package and is licensed under the
** GPLv3. For support on developing in nuBuilder, please visit the nuBuilder
** wiki and forums. For details on contributing a patch for nuBuilder, please
** visit the `Project Contributions' forum.
**
**   Website:  http://www.nubuilder.com
**   Wiki:     http://wiki.nubuilder.com
**   Forums:   http://forums.nubuilder.com
*/

require_once("phpmailer-5.1/class.phpmailer.php");
require_once("config.php");

function nuSendEmail($to, $from = "noreply@localhost", $content = "nuBuilder Email", $html = false, $subject = "", $wordWrap = 120, $filelist, $receipt = "false") {

        $mail = new PHPMailer();

        switch ($GLOBALS["NUMailMethod"])
        {
			// Use the sendmail binary.
        case "sendmail":
        {
                $mail->IsSendmail();
                break;
        } // case
			// Use an SMTP server to send the mail.
        case "smtp":
        {
                $mail->IsSMTP();
                $mail->Host     = (!empty($GLOBALS["NUSMTPHost"]))		? $GLOBALS["NUSMTPHost"] : "127.0.0.1";
                $mail->Port     = (!empty($GLOBALS["NUSMTPPort"]))		? $GLOBALS["NUSMTPPort"] : "25";
                $mail->SMTPSecure = ($GLOBALS["NUSMTPUseSSL"])			? 'tls' : '';
                $mail->SMTPAuth = (!empty($GLOBALS["NUSMTPUsername"]))	? true : false;
                if ($mail->SMTPAuth)
                {
                        $mail->Username = (!empty($GLOBALS["NUSMTPUsername"])) ? $GLOBALS["NUSMTPUsername"] : "";
                        $mail->Password = (!empty($GLOBALS["NUSMTPPassword"])) ? $GLOBALS["NUSMTPPassword"] : "";
                } // if
	} // case
			// Use PHP's built-in mail function.
	case "mail":
        default:
	{
					// Nothing to do, "mail" is the PHPMailer default.
        } // default
        } // switch
// END - 2009/06/09 - Michael

	if($receipt == "true"){
		$mail->ConfirmReadingTo = $from;
	}
		
        if(empty($from)){
            $mail->SetFrom('noreply@localhost', '');
			$mail->AddReplyTo('noreply@localhost');
        }else{
            $mail->SetFrom($from, '');
			$mail->AddReplyTo($from);
        }
		
		$toArray = explode(',',$to);
		for($i = 0; $i < count($toArray); $i++){
			if($toArray[$i]){
				$mail->AddAddress($toArray[$i]);
			}
		}
        $mail->WordWrap = $wordWrap;
        $mail->IsHTML($html);
		if(isset($filelist)) {
			foreach($filelist as $filename=>$filesource) {
				$mail->AddAttachment($filesource,$filename);
			}
		}
        $mail->Subject = $subject;
        $mail->Body    = $content;

		return $mail->Send();
}


?>
